package org.test.as7.messaging;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;

import org.jboss.logging.Logger;
import org.jboss.logging.Logger.Level;

@MessageDriven(name = "MyMessageBean",
        activationConfig = {
                @ActivationConfigProperty(
                        propertyName = "destinationType",
                        propertyValue = "javax.jms.Queue"),
                @ActivationConfigProperty(
                        propertyName = "destination",
                        propertyValue = "java:/queue/myMessageQueue")
        })
//@MessageDriven(mappedName = "java:/queue/myMessageQueue",
//        activationConfig = {
//                @ActivationConfigProperty(
//                        propertyName = "destinationType",
//                        propertyValue = "javax.jms.Queue")
//        })
@TransactionManagement(TransactionManagementType.CONTAINER)
public class MessageConsumerBean implements MessageListener {

    private static Logger logger = Logger.getLogger(MessageConsumerBean.class);
    @Resource
    private MessageDrivenContext ctx;

    @Override
    @TransactionAttribute(TransactionAttributeType.REQUIRED)
    public void onMessage(final Message message) {

        try {
            logger.logv(Level.INFO, "Message received: {0}",
                    message.getStringProperty("message"));

        } catch (final JMSException jmse) {
            logger.logv(Level.ERROR, jmse.getMessage());
            ctx.setRollbackOnly();
        }
    }
}
